"""Install packages as defined in this file into the Python environment."""
import os
import glob
import shutil
import sys
import distro

from distutils.core import setup
from distutils.cmd import Command
from distutils.command.build import build
from distutils.command.install import install
from setuptools import setup, find_packages
import subprocess
import time

class Build(build):
    def run(self):
        os.system("mkdir -p build/share/pycarobd2")
        print ("Detect system...")
        dist = distro.id()
        if os.path.exists("DISTRO"):
            content = open("DISTRO").read().strip()
            if content:
                dist = content
        print ("Your distro is a: " + dist)
        rpm = [ "blackpantheros","redhat","fedora"]
        deb = [ "ubuntu", "linuxmint", "debian"]
        tgz = ["archlinux"]

        print ("Set distro background...")

        os.system("mkdir -p build/scripts-3.11")
        print ("Copying Desktop files...")
        os.system("mkdir -p build/share/applications/")
        print ("Copying Icons...")
        print ("Copying PYs Src...")
        os.system("cp *.py build/share/pycarobd2")
        os.system("cp -rf CONFIG DATA ICONS SAVE build/share/pycarobd2")
        
        print ("Catting...")
        os.system("mkdir -p  build/scripts-3.11")

        for filename in glob.glob1("./", "*.py"):
            if filename not in ["setup.py"]:
                print("Name: ", filename)
                os.system("cat %s > build/scripts-3.11/%s" % (filename, filename[:-3]))

        print ("Build locales...")
        for filename in glob.glob1("po", "*.po"):
            lang = filename.rsplit(".", 1)[0]
            os.system("msgfmt po/%s.po -o po/%s.mo" % (lang, lang))
            try:
                os.makedirs(os.path.join(locale_dir, "%s/LC_MESSAGES" % lang))
            except OSError:
                pass
            shutil.copy("po/%s.mo" % lang, os.path.join(locale_dir, "%s/LC_MESSAGES" 
                                                    % lang, "%s.mo" % pkgname))


class Install(install):
    def run(self):
        print ("Skip..:")
        #install.run(self)

setup(
    name="pyCarODB2",
    author="Charles K Barcza",
    author_email="kbarcza@blackpanther.hu",
    url="http://www.blackpanther.hu",
    description="OBDII data reader",
    version="20230223",
    packages=find_packages(where=".", exclude=["tests"]),
    include_package_data=True,
    package_data={"pyCarODB2": ["pyCarODB/resources/*"]},
    install_requires=[
        "setuptools>=45.0",
        "pygame",
        "serial",
        "pypdf2",
    ],
    entry_points={
        "console_scripts": [
            "pyCarODB2=pyCarODB.__main__:main",
        ]
    },
    classifiers=[
        "Development Status :: 1 - Release",
        "Programming Language :: Python :: 3.0",
        "Topic :: Utilities",
    ],

    package_dir={"pycarobd2":"."},
    scripts=["build/scripts-3.11/pycarobd2"],
    data_files  = [('/'.join(e.split('/')[1:-1]), [e]) for e in subprocess.getoutput("find build/share/locale").split() if ".mo" in e],

    cmdclass = {
        'build_ext': Build,
        'install': Install,
    }
)

